
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Android开发之IPC进程间通信-AIDL介绍及实例解析 / 憋错料</title>

    <meta name="description" content="Android开发之IPC进程间通信-AIDL介绍及实例解析 一.IPC进程间通信 IPC是进程间通信方法的统称,Linux IPC包括以下方法,Android的进程间通信主要采用是哪些方法呢? 1. 管道(Pipe)及有名管道(named pipe):管道可用于具有亲缘关系进程间的通信,有名管道克服了管道没有名字的限制,因此,除具有管道所具有的功能外,它还允许无亲缘关系进程间的通信:   2. 信号(Signal):信号是比较复杂的通信方式,用于通知接受进程有某种事件发生,除了用于进程间通信外,进程还可以发送信号给进程本身:linux除了支持Unix早期">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Android开发之IPC进程间通信-AIDL介绍及实例解析</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p><strong>一、IPC进程间通信</strong></p>
<p>IPC是进程间通信方法的统称，Linux IPC包括以下方法，Android的进程间通信主要采用是哪些方法呢?</p>
<p>1. 管道（Pipe）及有名管道（named pipe）：管道可用于具有亲缘关系进程间的通信，有名管道克服了管道没有名字的限制，因此，除具有管道所具有的功能外，它还允许无亲缘关系进程间的通信；<br />&nbsp;&nbsp; 2. 信号（Signal）：信号是比较复杂的通信方式，用于通知接受进程有某种事件发生，除了用于进程间通信外，进程还可以发送信号给进程本身；linux除了支持Unix早期信号语义函数sigal外，还支持语义符合Posix.1标准的信号函数sigaction（实际上，该函数是基于BSD的，BSD为了实现可靠信号机制，又能够统一对外接口，用sigaction函数重新实现了signal函数）；<br />&nbsp;&nbsp; 3. 报文（Message）队列（消息队列）：消息队列是消息的链接表，包括Posix消息队列system V消息队列。有足够权限的进程可以向队列中添加消息，被赋予读权限的进程则可以读走队列中的消息。消息队列克服了信号承载信息量少，管道只能承载无格式字节流以及缓冲区大小受限等缺点。<br />&nbsp;&nbsp; 4. 共享内存：使得多个进程可以访问同一块内存空间，是最快的可用IPC形式。是针对其他通信机制运行效率较低而设计的。往往与其它通信机制，如信号量结合使用，来达到进程间的同步及互斥。<br />&nbsp;&nbsp; 5. 信号量（semaphore）：主要作为进程间以及同一进程不同线程之间的同步手段。<br />&nbsp;&nbsp; 6. 套接口（Socket）：更为一般的进程间通信机制，可用于不同机器之间的进程间通信。起初是由Unix系统的BSD分支开发出来的，但现在一般可以移植到其它类Unix系统上：Linux和System V的变种都支持套接字。</p>
<p><strong>二、AIDL（Android Interface Definition Language）</strong></p>
<p>AIDL - Android Interface Definition Language - Android 接口定义语言。因为在Android中，应用程序运行在各自独立的进程里。应用程序之间是不能访问对方的内存空间的。有时为了实现进程间的通信，要用到PCI机制。Android支持PCI机制，但是需要Android能读懂的序列化数据（marshaling/un marshaling of data）.&nbsp; &nbsp; AIDL就是为了描述这样的数据产生的，它是一种接口定义语言。语法类似JAVA，.aidl文件里面写的是公布给客户端接口声明。</p>
<p>本文中，为了吸取客户端，服务器端两个android 项目的经验，将两段整合到一个android项目里，这样可能会比较清晰。下面就看看实例解析吧。</p>
<p><strong>三、AIDL介绍及解析</strong></p>
<p><strong>1.AIDL介绍</strong></p>
<p>在Android中，每个应用（Application）执行在它自己的进程中，无法直接调用到其他应用的资源，这也符合&ldquo;沙箱&rdquo;的理念。所谓沙箱原理，一般来说用在移动电话业务中，简单地说旨在部分地或全部地隔离应用程序。关于沙箱技术我们这里就不多做介绍了。因此，在Android中，当一个应用被执行时，一些操作是被限制的，比如访问内存，访问传感器，等等。这样做可以最大化地保护系统，免得应用程序&ldquo;为所欲为&rdquo;。那我们有时需要在应用间交互，怎么办呢？于是，Android需要实现IPC协议。然而，这个协议还是有点复杂，主要因为需要实现数据管理系统（在进程或线程间传递数据）。Android为我们实现了自己的IPC，也就是AIDL。</p>
<p><strong>2.定义AIDL接口</strong></p>
<p>AIDL是IPC的一个轻量级实现，用了对于Java开发者来说很熟悉的语法。Android也提供了一个工具，可以自动创建Stub（类构架，类骨架）。当我们需要在应用间通信时，我们需要按以下几步走：</p>
<p>a. 定义一个AIDL接口</p>
<p>b. 为远程服务（Service）实现对应Stub</p>
<p>c. 将服务&ldquo;暴露&rdquo;给客户程序使用</p>
<p><strong>3.实例解析</strong></p>
<p>AIDL的语法很类似Java的接口（Interface），只需要定义方法的签名。</p>
<p>AIDL支持的数据类型与Java接口支持的数据类型有些不同</p>
<p>a. 所有基础类型（int, char, 等）</p>
<p>b. String，List，Map，CharSequence等类</p>
<p>c. 其他AIDL接口类型</p>
<p>d. 所有Parcelable的类</p>
<p>下面以一个加法器为例来做解析。</p>
<p>（1）创建工程，创建AIDL接口：新建一个文件，命名为IAdditionService.aidl 即可</p>
<pre>package com.czm.hellosumaidl;

interface IAdditionService{
    int add(int value1,int value2);
}</pre>
<p>一旦文件被保存，Android的AIDL工具会在&nbsp;<strong>gen/com/android/hellosumaidl&nbsp;</strong>这个文件夹里自动生成对应的&nbsp;<strong>IAdditionService.java&nbsp;</strong>这个文件。因为是自动生成的，所以无需改动。这个文件里就包含了&nbsp;<strong>Stub&nbsp;</strong>，我们接下来要为我们的远程服务实现这个Stub。</p>
<p>（2）实现远程服务</p>
<p>首先我们新建一个类，取名叫<strong>AdditionService.java&nbsp;</strong>。为了&nbsp;实现我们&nbsp;的服务，我们需要让&nbsp;这个&nbsp;类中的&nbsp;<strong>onBind</strong>方法返回一个&nbsp;<strong>IBinder&nbsp;</strong>类的对象。这个&nbsp;<strong>IBinder&nbsp;</strong>类的对象就代表了远程服务的实现。为了实现这个服务，我们要用到自动生成的子类&nbsp;<strong>IAdditionService.Stub&nbsp;</strong>。在其中，我们也必须实现我们之前在AIDL文件中定义的&nbsp;<strong>add()&nbsp;</strong>函&nbsp;数。下面是我们远程服务的代码：</p>
<pre>public class AdditionService extends Service{

    @Override
    public void onCreate() {
        super.onCreate();
    } 

    @Override
    public IBinder onBind(Intent intent) {
        // TODO Auto-generated method stub
        return new IAdditionService.Stub() {

            @Override
            public int add(int value1, int value2) throws RemoteException {
                // TODO Auto-generated method stub
                return value1 + value2;
            }
        };
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
    } 

}</pre>
<p>（3）提供服务（&ldquo;暴露&rdquo;服务给使用者）</p>
<p>一旦实现了服务中的onBind方法&nbsp;，我们就可以把客户程序（在这里是<strong>MainActivity.java&nbsp;</strong>）与服务连接起来了。为了建立这样的一个链接&nbsp;，我们需要实现&nbsp;<strong>ServiceConnection&nbsp;</strong>类。我们在&nbsp;<strong><strong>MainActivity.java&nbsp;</strong></strong>创建一个内部类&nbsp;<strong>AdditionServiceConnection&nbsp;</strong>，这个类继承&nbsp;<strong>ServiceConnection&nbsp;</strong>类，并且重写了它的两个方法：&nbsp;<strong>onServiceConnected&nbsp;</strong>和&nbsp;<strong>onServiceDisconnected</strong>。下面给出&nbsp;内部类的代码：</p>
<pre>class AdditionServiceConnection implements ServiceConnection {

        @Override
        public void onServiceConnected(ComponentName name, IBinder boundService) {
            // TODO Auto-generated method stub
            service = IAdditionService.Stub.asInterface((IBinder) boundService);
            Toast.makeText(MainActivity.this, "Service connected",
                    Toast.LENGTH_SHORT).show();
        }

        @Override
        public void onServiceDisconnected(ComponentName name) {
            // TODO Auto-generated method stub
            service = null;
            Toast.makeText(MainActivity.this, "Service disconnected",
                    Toast.LENGTH_SHORT).show();
        }

    }</pre>
<p>（4）相关代码及效果截图</p>
<p>MainActivity.java的全部代码如下：</p>
<pre>package com.czm.hellosumaidl;

import android.app.Activity;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.ServiceConnection;
import android.os.Bundle;
import android.os.IBinder;
import android.os.RemoteException;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

public class MainActivity extends Activity {

    IAdditionService service;
    AdditionServiceConnection connection;
    EditText value1;
    EditText value2;
    TextView result;
    Button buttonCalc;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        initService();

        buttonCalc = (Button) findViewById(R.id.buttonCalc);

        value1 = (EditText) findViewById(R.id.value1);
        value1.setText("23");
        value2 = (EditText) findViewById(R.id.value2);
        value2.setText("24");
        result = (TextView) findViewById(R.id.result);
        buttonCalc.setOnClickListener(new OnClickListener() {

            @Override
            public void onClick(View v) {
                int v1, v2, res = -1;
                v1 = Integer.parseInt(value1.getText().toString());
                v2 = Integer.parseInt(value2.getText().toString());

                try {
                    res = service.add(v1, v2);
                } catch (RemoteException e) {
                    e.printStackTrace();
                }

                result.setText(Integer.valueOf(res).toString());
            }
        });
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        releaseService();
    }

    /*
     * This function connects the Activity to the service
     */
    private void initService() {
        connection = new AdditionServiceConnection();

        Intent i = new Intent();
        i.setClassName("com.czm.hellosumaidl",com.czm.hellosumaidl.AdditionService.class.getName());
        boolean ret = this.bindService(i, connection, Context.BIND_AUTO_CREATE);
    }

    /*
     * This function disconnects the Activity from the service
     */
    private void releaseService() {
        unbindService(connection);
        connection = null;
    }

    class AdditionServiceConnection implements ServiceConnection {

        @Override
        public void onServiceConnected(ComponentName name, IBinder boundService) {
            // TODO Auto-generated method stub
            service = IAdditionService.Stub.asInterface((IBinder) boundService);
            Toast.makeText(MainActivity.this, "Service connected",
                    Toast.LENGTH_SHORT).show();
        }

        @Override
        public void onServiceDisconnected(ComponentName name) {
            // TODO Auto-generated method stub
            service = null;
            Toast.makeText(MainActivity.this, "Service disconnected",
                    Toast.LENGTH_SHORT).show();
        }

    }

}</pre>
<p>效果截图如下：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9pLzMyMjkxOS8yMDE0MDcvMjIxOTIyMjQyNzU4Mjg5LnBuZw==.jpg" />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp;&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9pLzMyMjkxOS8yMDE0MDcvMjIxOTIyMzM0NDc1NDU0LnBuZw==.jpg" /></p>
<p>执行AIDL接口之前 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;&nbsp;执行AIDL接口之后</p>
<p><P><A href="http://www.bubuko.com/infodetail-270308.html" rel="external nofollow noreferrer">Android开发之IPC进程间通信-AIDL介绍及实例解析,布布扣,bubuko.com</A></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 21:46:00 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/style/" title="style">style</a>, <a href="https://www.biecuoliao.com/tag/des/" title="des">des</a>, <a href="https://www.biecuoliao.com/tag/http/" title="http">http</a>, <a href="https://www.biecuoliao.com/tag/java/" title="java">java</a>, <a href="https://www.biecuoliao.com/tag/blog/" title="blog">blog</a>, <a href="https://www.biecuoliao.com/tag/android/" title="android">android</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Android开发之IPC进程间通信-AIDL介绍及实例解析的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4QqvLl4.html" rel="bookmark">Android开发之UI更新交互机制与实例解析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				android开发过程中,经常需要更新UI的状态和文案等.这是就需要对UI进行 更新.在android中更新UI一般有三种方法,handler机制.RunOnUiThread方法以及AsyncTask异步类方法等 本文下面就这三种方法进行了演示和代码实现. a.Handler机制通过使用消息机制来实现 b.RunOnUiThread方法是通过运行UI线程来达到更新UI的目的 c.AsyncTask是异步类,通过异步更新来更新UI 效果图如下:           (1)Java功能实现代码如下:			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MoanJl3.html" rel="bookmark">Android快速开发之appBase&mdash;&mdash;&lpar;1&rpar;&period;appBase介绍</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android快速开发之appBase--(1).appBase介绍 一直想写博客,苦于自己的文笔实在不行,在CSDN潜水了好几年,中间差不多3年没有写过博客.原因有二:1.文笔差:2.没时间. 今年开始,时间充裕了,开始计划练练自己的文笔,也让自己成长起来,希望从中能够提升自己的能力.望大家多多支持和关注!! 导读:appBase是什么? appBase是一个Android app开发的基础集合,目的是任何应用都可以在这个基础之上开发app,省去了搭建框架的时间. appBase=xutils			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MElgoP4.html" rel="bookmark">Android开发之WebService介绍</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				经常有网友问:“在Android平台如何调用WebService”?经过沟通我发现,甚至有些朋友连什么是WebSerivce都不知道就在问怎么使用,更别说和WebService有关的SOAP.WSDL这类“火星”名词了.所以,我就想在讲解Android平台如何调用WebSerivce之前,先来介绍下WebService,看看它到底有多神秘.      记得我的硕士论文题目中就包含“Web Service”这个词,当时还是花了大量时间去研究Web Service在系统集成.企业应用整合方面的应用:			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3Ze98d0.html" rel="bookmark">Android开发之Sensors与摇一摇</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Sensor概述 基于Android的设备有内置的传感器,测量运动,方向,和各种环境条件.这些传感器能够提供原始数据的高精度和准确度,并且是有用的如果你想要监测装置.定位的三维运动,或者你想监控在设备周围环境的变化.例如,一个可能的轨道的读数装置的重力传感器来推断用户的手势和身体的动作复杂,如倾斜.摇晃.旋转.摆动或.同样,一个天气应用程序可能使用的设备的温度传感器和湿度传感器来计算和报告. Android平台支持的传感器三大类: 运动传感器 这些传感器测量加速度的力和旋转力沿三轴.这一类包括加			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDkD184.html" rel="bookmark">【转】Android开发之旅：进程与线程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				引言 当应用程序的组件第一次运行时,Android将启动一个只有一个执行线程的Linux进程.默认,应用程序所有的组件运行在这个进程和线程中.然而,你可以安排组件运行在其他进程中,且你可以为进程衍生出其它线程.本文从下面几点来介绍Android的进程与线程: 1.进程 2.线程 2.1.远程过程调用(Remote procedure calls,RPCs) 2.2.线程安全方法 1.进程 组件运行于哪个进程中由清单文件控制.组件元素——&lt;activity&gt;.&lt;service&gt;.&l			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/k0ePlgM.html" rel="bookmark">Android开发之Tween&lpar;补间动画&rpar;完全解析&lpar;下&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				欢迎转载,转载请注明出处:http://blog.csdn.net/dmk877/article/details/51980734 在上一篇文章中,我们详细讨论了Tween动画的xml的实现以及interpolator的使用,相信通过上篇文章大家对Tween动画的xml属性的配置会有一个详细的理解,当然这篇文章也是承接上篇文章,所以强烈建议先阅读上篇文章:Android开发之Tween(补间动画)完全解析(上),这篇文章将从代码的角度实现上篇文章的效果.如有疑问请留言,如有谬误欢迎批评指正. T			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/388qJK3.html" rel="bookmark">Android开发之Fragment详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android开发之Fragment学习 1.简介: Fragment是Android 3.0引入的新API. Fragment代表了 Activity的子模块,因此可以把Fragment理解成Activity片段.Fragment用于自己的生命周期,也可以接受它自己的输入事件. Fragment必须被&quot;嵌入&quot; Activity中使用,因此虽然Fragment也拥有自己的生命周期,但Fragment的生命周期会受它所在的Activity的生命周期的控制.例如,当Activity暂停时,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4Am7ry4.html" rel="bookmark">Android开发之Html类详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在进行Android开发中经常回忽略Html类.这个类其实很简单,就是将HTML标签文本解析成普通的样式文本.下面就让我么看一下这个类的具体介绍. 类结构: java.lang.Object    ? android.text.Html 类概述: 这个类用于处理的HTML字符串并将其转换成可显示的样式文本.但并不是所有的HTML标记的支持. 公有方法: 说其简单是应为它就有四个方法: Public Methods static String escapeHtml(CharSequence tex			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgPWNn0.html" rel="bookmark">Android开发之InstanceState详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android开发之InstanceState详解 本文介绍Android中关于Activity的两个神秘方法:onSaveInstanceState() 和 onRestoreInstanceState(),并且在介绍这两个方法之后,再分别来实现使用InstanceState保存和恢复数据功能.Android实现屏幕旋转异步下载效果这样两个示例. 首先来介绍onSaveInstanceState() 和 onRestoreInstanceState() .关于这两个方法,一些朋友可能在Andr			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEkj6Z3.html" rel="bookmark" class="title">Android内存泄漏检测与MAT使用</a>
					<div>
						内存泄漏基本概念 内存检测这部分,相关的知识有JVM虚拟机垃圾收集机制,类加载机制,内存模型等.编写没有内存泄漏的程序,对提高程序稳定性,提高用户体验具有重要的意义.因此,学习java利用java编写 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kX6Rd3.html" rel="bookmark" class="title">鸡和框架</a>
					<div>
						集合框架 在Java语言中,Java语言的设计者对常用的数据结构和算法做了一些规范(接口)和实现(具体实现接口的类).所有抽象出来的数据结构和操作(算法)统称为Java集合框架(JavaCollect ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPdbOaM.html" rel="bookmark" class="title">临时上传的文件-20160831</a>
					<div>
						文件名(排序) 大小(排序) 上传时间(排序)     openstack-install-guide-yum-kilo.pdf 1553KB 8/31/2016 11:44:29 PM Downlo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmlPbp4.html" rel="bookmark" class="title">读《构建之法》1，2，3章后感</a>
					<div>
						读完构建之法1,2,3章后,我对软件工程有了初步的了解,所谓的软件工程就是一整套的开发,运营,维修等流程,软件工程把这流程规范化了.我明白了软件开发过程中遇到Bug是很正常的事,这需要我们开发者去通过 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vvLn63.html" rel="bookmark" class="title">Atitit。&amp;&num;160&semi;&amp;&num;160&semi;工作流引擎的发展趋势</a>
					<div>
						Atitit.  工作流引擎的发展趋势 1.1. 图灵完备1 1.2. 图形化与文本化1 1.3. Jit1 1.4. Dsl化2 1.5. Oo2 1.6. 托管与本地代码的互操作2 1.7. 大型 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qva6z4.html" rel="bookmark" class="title">备份工具之Xtrabackup</a>
					<div>
						Xtrabackup xtrabackup是基于InnoDB存储引擎灾难恢复的.它复制InnoDB的数据文件,尽管数据文件在内部是非一致性的,但在执行灾难恢复时可以保证这些数据文件是一致的,并且可用. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l5p7X3.html" rel="bookmark" class="title">N进制加法</a>
					<div>
						我是网络公司的一名普通程序员,英文名Steven,发音比较像“师弟”,自从入职培训自我介绍后,大家就称我为“二师弟”,我喜欢看科幻小说,也喜欢做梦,有一次梦到外星球,发现外星人使用的并非10进制/16 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NaeaB3.html" rel="bookmark" class="title">读《大道至简》第三章有感</a>
					<div>
						最近阅读了&lt;大道至简&gt;第三章,第三章主要讲的是团队问题,我们软件工程学生更应该理解这个主题.下面是我对这个主题的一些感悟. 时代需要英雄,但更需要优秀的团队.没有人能依靠一己之力获得某项事 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kGVld0.html" rel="bookmark" class="title">UIWebView使用小记</a>
					<div>
						对webview 加载的文本中所有的网址变成可点击操作处理(我的方法:过滤所有的网址,然后变成html中的超链接形式如:&lt;a href=&quot;http://www.baidu.com&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzAXrA4.html" rel="bookmark" class="title">Linux 根文件系统的制作</a>
					<div>
						一.建立根文件系统目录与文件 1. 创建目录 #mkdir rootfs #cd rootfs #mkdir bin dev etc lib proc sbin sys usr mnt tmp var ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3827zyM.html" rel="bookmark" class="title">php下的一个分页类</a>
					<div>
						这个分页类,参考了慕课网和燕十八的分页类. 慕课网分页类学习网址:http://www.imooc.com/learn/419 效果图: &lt;?php class page{    public  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nPwYj4.html" rel="bookmark" class="title">HUAS 1476 不等数列&lpar;DP&rpar;</a>
					<div>
						考虑DP. 如果把转移看出当前位填什么数的话,这样是有后效性的. 如果考虑当前的序列是将1至n依次插入序列中的话. 考虑将i插入1到i-1的序列中,如果插入到&lt;号中或者首部,那么最后就会多出一个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0koQ5j0.html" rel="bookmark" class="title">百思不得姐之立即登录注册模块&lpar;五&rpar;</a>
					<div>
						一 功能图和实现思路 具体功能图: 实现思路: --&gt; 1 关注控制器模块搭建(xib) --&gt; 2 登录和注册界面的总体模块数量(三个模块),可以用三个view来装各自的子控件 --&g ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l776ZM.html" rel="bookmark" class="title">均线向上</a>
					<div>
						MADAYS:=MA(VOL, DAYS);{N天均成交量}MADAYS_BEFORE:=REF(MADAYS, 5);{5天前的N天均成交量}R1:= IF((MADAYS &gt;= MADAYS ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38oNpW0.html" rel="bookmark" class="title">设计模式之-适配器</a>
					<div>
						在阎宏博士的&lt;JAVA与模式&gt;一书中开头是这样描述适配器(Adapter)模式的: 适配器模式把一个类的接口变换成客户端所期待的另一种接口,从而使原本因接口不匹配而无法在一起工作的两个类能 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41GnLG0.html" rel="bookmark" class="title">使用selenium自动登录126&sol;163邮箱并发送邮件</a>
					<div>
						我使用的是python2.7.13+selenium ps:几天之前,我曾多次尝试写这段代码,但是在点击写信的步骤时失败了,我想我的问题应该大致是这几点: 1.写信按钮不能直接定位到,同时它的父目录i ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xej6j3.html" rel="bookmark" class="title">28&period;QOS服务质量（1）</a>
					<div>
						QOS服务质量是一种解决网络拥塞的方法,把现有的网络资源,合理的分配使用. QOS技术分为:流分类/标识,限速,拥塞避免和拥塞管理四个部分. 流分类/标识: 对于流量的分类我们可以通过ACL来做分类. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0aGaKA4.html" rel="bookmark" class="title">C&num;调用Win32 api学习总结</a>
					<div>
						从.NET平台调用Win32 API Win32 API可以直接控制Microsoft Windows的核心,因为API(Application Programming Interface)本来就是微 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02rNKR0.html" rel="bookmark" class="title">Android多线程下载单个文件和断点续传</a>
					<div>
						实现要点: (1)创建一个线程数组用于多个线程同时开工下载 (2)通过http连接获取文件的大小信息,然后按照线程个数来分配各个线程下载的文件片段 (3)通过http的Range头来请求文件的片段 ( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02rvBa0.html" rel="bookmark" class="title">学会使用RecyclerView  及Arrays&period;asList函数</a>
					<div>
						要实现ListView列表的循环滚动效果,其实可以用RecyclerView实现. Runnable run = new Runnable() { @Override public void run( ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 11 q. 0.037 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
